#include "Arduino.h"
#include "LightLetter.h"

//  constructor
LightLetter::LightLetter() {
    inUse = false;
}

void LightLetter::setup(String letter, float xPos, float aOffSet, float width) {
    _letter = letter;
    _xPos = xPos;
    
    _angleOffSet = aOffSet;
    _width = width *2;
    
   // _dToWall = dToWall;
   // _xOffSet = xOffSet;
    
    //calculate angle offset?
   /* float a = atan2(_dToWall,_xPos+_xOffSet);
    float b = atan2(_dToWall, _xPos);
    float c = b-a;
    c = radiansToDegrees(c);
    _aOffSet = c;*/
    
    //_aOffSet = atan2(_dToWall, xOffSet);
    //_aOffSet = radiansToDegrees(_aOffSet);
}

void LightLetter::attachPin(int pin){
    _servo.attach(pin);
}

/* Set the x position of the light letter
    in inches from the center of the wall */
void LightLetter::setXIn(float targetX) {
    //solve for A
   // float tan = _xPos/_dToWall;
  //  float a = atan2(_xPos,_dToWall);
    
    //offset target x for calibration
   // targetX += _xOffSet;
    
    //offset targetX by letter width
    targetX += _width/2;
    
    float relXPos = _xPos * -1;
    float ax = targetX + relXPos;
    float bx = relXPos;
    
    float a = atan2(dToWall,ax);
    

    //solve for B
    //tan = (targetX-_xPos)/_dToWall;
   // float b = atan2((targetX - _xPos),_dToWall);
    float b = atan2(dToWall,bx);

    
    //convert to degrees from radians
   // a = radiansToDegrees(a);
   // b = radiansToDegrees(b);
    
    //solve for C
    float c = (b-a)/2;
    //convert to degrees from radians
    float targetAngle = radiansToDegrees(c);
    
    
    //calculate offset
    /* bx = targetX - _xPos;
     ax = bx + _xOffSet;
    a = atan2(dToWall,ax);
    b = atan2(dToWall, bx);
    float angleOffSet = b-a;
    angleOffSet = radiansToDegrees(angleOffSet);
    
    targetAngle += angleOffSet;*/
    
    
    // Serial.println(c);
    
    //turn motor
    targetAngle*=-1;
    targetAngle += 90;
    
    //IS IT GOING OUT OF BOUNDS HERE?
    
    //offset
    targetAngle += _angleOffSet;
   // Serial.println(targetAngle);
    setAngle(targetAngle);
    //setAngle(90);
}

void LightLetter::setAngle(int a){
    _servo.write(a);
}

float LightLetter::radiansToDegrees(float rad){
    float deg = (rad * 4068) / 71;
    return deg;
}

//move letter to "hidden" place
void LightLetter::hide(){
    if(_xPos > 0){
        setXIn(60);
    }
    else{
        setXIn(-70);
    }
}